diff --git a/src/include/pg_config.h.in b/src/include/pg_config.h.in
index 92fcc5f3063..9d404144800 100644
--- a/src/include/pg_config.h.in
+++ b/src/include/pg_config.h.in
@@ -22,21 +22,21 @@
 #undef ALIGNOF_SHORT
 
 /* Size of a disk block --- this also limits the size of a tuple. You can set
-   it bigger if you need bigger tuples (although TOAST should reduce the need
-   to have large tuples, since fields can be spread across multiple tuples).
-   BLCKSZ must be a power of 2. The maximum possible value of BLCKSZ is
-   currently 2^15 (32768). This is determined by the 15-bit widths of the
-   lp_off and lp_len fields in ItemIdData (see include/storage/itemid.h).
-   Changing BLCKSZ requires an initdb. */
+	it bigger if you need bigger tuples (although TOAST should reduce the need
+	to have large tuples, since fields can be spread across multiple tuples).
+	BLCKSZ must be a power of 2. The maximum possible value of BLCKSZ is
+	currently 2^15 (32768). This is determined by the 15-bit widths of the
+	lp_off and lp_len fields in ItemIdData (see include/storage/itemid.h).
+	Changing BLCKSZ requires an initdb. */
 #undef BLCKSZ
 
 /* Saved arguments from configure */
 #undef CONFIGURE_ARGS
 
 /* Define to the default TCP port number on which the server listens and to
-   which clients will try to connect. This can be overridden at run-time, but
-   it's convenient if your clients have the right default compiled in.
-   (--with-pgport=PORTNUM) */
+	which clients will try to connect. This can be overridden at run-time, but
+	it's convenient if your clients have the right default compiled in.
+	(--with-pgport=PORTNUM) */
 #undef DEF_PGPORT
 
 /* Define to the default TCP port number as a string constant. */
@@ -76,59 +76,59 @@
 #undef HAVE_CRTDEFS_H
 
 /* Define to 1 if you have the declaration of `fdatasync', and to 0 if you
-   don't. */
+	don't. */
 #undef HAVE_DECL_FDATASYNC
 
 /* Define to 1 if you have the declaration of `F_FULLFSYNC', and to 0 if you
-   don't. */
+	don't. */
 #undef HAVE_DECL_F_FULLFSYNC
 
 /* Define to 1 if you have the declaration of
-   `LLVMCreateGDBRegistrationListener', and to 0 if you don't. */
+	`LLVMCreateGDBRegistrationListener', and to 0 if you don't. */
 #undef HAVE_DECL_LLVMCREATEGDBREGISTRATIONLISTENER
 
 /* Define to 1 if you have the declaration of
-   `LLVMCreatePerfJITEventListener', and to 0 if you don't. */
+	`LLVMCreatePerfJITEventListener', and to 0 if you don't. */
 #undef HAVE_DECL_LLVMCREATEPERFJITEVENTLISTENER
 
 /* Define to 1 if you have the declaration of `memset_s', and to 0 if you
-   don't. */
+	don't. */
 #undef HAVE_DECL_MEMSET_S
 
 /* Define to 1 if you have the declaration of `posix_fadvise', and to 0 if you
-   don't. */
+	don't. */
 #undef HAVE_DECL_POSIX_FADVISE
 
 /* Define to 1 if you have the declaration of `preadv', and to 0 if you don't.
-   */
+	*/
 #undef HAVE_DECL_PREADV
 
 /* Define to 1 if you have the declaration of `pwritev', and to 0 if you
-   don't. */
+	don't. */
 #undef HAVE_DECL_PWRITEV
 
 /* Define to 1 if you have the declaration of `strchrnul', and to 0 if you
-   don't. */
+	don't. */
 #undef HAVE_DECL_STRCHRNUL
 
 /* Define to 1 if you have the declaration of `strlcat', and to 0 if you
-   don't. */
+	don't. */
 #undef HAVE_DECL_STRLCAT
 
 /* Define to 1 if you have the declaration of `strlcpy', and to 0 if you
-   don't. */
+	don't. */
 #undef HAVE_DECL_STRLCPY
 
 /* Define to 1 if you have the declaration of `strnlen', and to 0 if you
-   don't. */
+	don't. */
 #undef HAVE_DECL_STRNLEN
 
 /* Define to 1 if you have the declaration of `strsep', and to 0 if you don't.
-   */
+	*/
 #undef HAVE_DECL_STRSEP
 
 /* Define to 1 if you have the declaration of `timingsafe_bcmp', and to 0 if
-   you don't. */
+	you don't. */
 #undef HAVE_DECL_TIMINGSAFE_BCMP
 
 /* Define to 1 if you have the <editline/history.h> header file. */
@@ -153,7 +153,7 @@
 #undef HAVE_GCC__ATOMIC_INT32_CAS
 
 /* Define to 1 if you have __atomic_compare_exchange_n(int64 *, int64 *,
-   int64). */
+	int64). */
 #undef HAVE_GCC__ATOMIC_INT64_CAS
 
 /* Define to 1 if you have __sync_lock_test_and_set(char *) and friends. */
@@ -166,7 +166,7 @@
 #undef HAVE_GCC__SYNC_INT32_TAS
 
 /* Define to 1 if you have __sync_val_compare_and_swap(int64_t *, int64_t,
-   int64_t). */
+	int64_t). */
 #undef HAVE_GCC__SYNC_INT64_CAS
 
 /* Define to 1 if you have the `getauxval' function. */
@@ -341,18 +341,18 @@
 #undef HAVE_RL_COMPLETION_MATCHES
 
 /* Define to 1 if you have the global variable 'rl_completion_suppress_quote'.
-   */
+	*/
 #undef HAVE_RL_COMPLETION_SUPPRESS_QUOTE
 
 /* Define to 1 if you have the `rl_filename_completion_function' function. */
 #undef HAVE_RL_FILENAME_COMPLETION_FUNCTION
 
 /* Define to 1 if you have the global variable 'rl_filename_quote_characters'.
-   */
+	*/
 #undef HAVE_RL_FILENAME_QUOTE_CHARACTERS
 
 /* Define to 1 if you have the global variable 'rl_filename_quoting_function'.
-   */
+	*/
 #undef HAVE_RL_FILENAME_QUOTING_FUNCTION
 
 /* Define to 1 if you have the `rl_reset_screen_size' function. */
@@ -575,7 +575,7 @@
 #undef MEMSET_LOOP_LIMIT
 
 /* Define to the OpenSSL API version in use. This avoids deprecation warnings
-   from newer OpenSSL versions. */
+	from newer OpenSSL versions. */
 #undef OPENSSL_API_COMPAT
 
 /* Define to the address where bug reports for this package should be sent. */
@@ -597,18 +597,18 @@
 #undef PACKAGE_VERSION
 
 /* Define to best C++ printf format archetype, usually gnu_printf if
-   available. */
+	available. */
 #undef PG_CXX_PRINTF_ATTRIBUTE
 
 /* Define to best C printf format archetype, usually gnu_printf if available.
-   */
+	*/
 #undef PG_C_PRINTF_ATTRIBUTE
 
 /* Define to the name of a signed 128-bit integer type. */
 #undef PG_INT128_TYPE
 
 /* Define to the name of the default PostgreSQL service principal in Kerberos
-   (GSSAPI). (--with-krb-srvnam=NAME) */
+	(GSSAPI). (--with-krb-srvnam=NAME) */
 #undef PG_KRB_SRVNAM
 
 /* PostgreSQL major version as a string */
@@ -630,24 +630,24 @@
 #undef PG_VERSION_STR
 
 /* Define to 1 to allow profiling output to be saved separately for each
-   process. */
+	process. */
 #undef PROFILE_PID_DIR
 
 /* Define to necessary symbol if this constant uses a non-standard name on
-   your system. */
+	your system. */
 #undef PTHREAD_CREATE_JOINABLE
 
 /* RELSEG_SIZE is the maximum number of blocks allowed in one disk file. Thus,
-   the maximum size of a single file is RELSEG_SIZE * BLCKSZ; relations bigger
-   than that are divided into multiple files. RELSEG_SIZE * BLCKSZ must be
-   less than your OS' limit on file size. This is often 2 GB or 4GB in a
-   32-bit operating system, unless you have large file support enabled. By
-   default, we make the limit 1 GB to avoid any possible integer-overflow
-   problems within the OS. A limit smaller than necessary only means we divide
-   a large relation into more chunks than necessary, so it seems best to err
-   in the direction of a small limit. A power-of-2 value is recommended to
-   save a few cycles in md.c, but is not absolutely required. Changing
-   RELSEG_SIZE requires an initdb. */
+	the maximum size of a single file is RELSEG_SIZE * BLCKSZ; relations bigger
+	than that are divided into multiple files. RELSEG_SIZE * BLCKSZ must be
+	less than your OS' limit on file size. This is often 2 GB or 4GB in a
+	32-bit operating system, unless you have large file support enabled. By
+	default, we make the limit 1 GB to avoid any possible integer-overflow
+	problems within the OS. A limit smaller than necessary only means we divide
+	a large relation into more chunks than necessary, so it seems best to err
+	in the direction of a small limit. A power-of-2 value is recommended to
+	save a few cycles in md.c, but is not absolutely required. Changing
+	RELSEG_SIZE requires an initdb. */
 #undef RELSEG_SIZE
 
 /* The size of `intmax_t', as computed by sizeof. */
@@ -717,7 +717,7 @@
 #undef USE_LIBXML
 
 /* Define to 1 to use XSLT support when building contrib/xml2.
-   (--with-libxslt) */
+	(--with-libxslt) */
 #undef USE_LIBXSLT
 
 /* Define to 1 to build with LLVM based JIT support. (--with-llvm) */
@@ -750,6 +750,9 @@
 /* Define to 1 to use SVE popcount instructions with a runtime check. */
 #undef USE_SVE_POPCNT_WITH_RUNTIME_CHECK
 
+/* Define to 1 to use SVE2 CRC instructions with a runtime check. */
+#undef USE_SVE2_CRC32C_WITH_RUNTIME_CHECK
+
 /* Define to build with systemd support. (--with-systemd) */
 #undef USE_SYSTEMD
 
@@ -772,7 +775,7 @@
 #undef USE_ZSTD
 
 /* Define WORDS_BIGENDIAN to 1 if your processor stores words with the most
-   significant byte first (like Motorola and SPARC, unlike Intel). */
+	significant byte first (like Motorola and SPARC, unlike Intel). */
 #if defined AC_APPLE_UNIVERSAL_BUILD
 # if defined __BIG_ENDIAN__
 #  define WORDS_BIGENDIAN 1
@@ -784,10 +787,10 @@
 #endif
 
 /* Size of a WAL file block. This need have no particular relation to BLCKSZ.
-   XLOG_BLCKSZ must be a power of 2, and if your system supports O_DIRECT I/O,
-   XLOG_BLCKSZ must be a multiple of the alignment requirement for direct-I/O
-   buffers, else direct I/O may fail. Changing XLOG_BLCKSZ requires an initdb.
-   */
+	XLOG_BLCKSZ must be a power of 2, and if your system supports O_DIRECT I/O,
+	XLOG_BLCKSZ must be a multiple of the alignment requirement for direct-I/O
+	buffers, else direct I/O may fail. Changing XLOG_BLCKSZ requires an initdb.
+	*/
 #undef XLOG_BLCKSZ
 
 
@@ -802,20 +805,20 @@
 #undef _LARGE_FILES
 
 /* Define to `__inline__' or `__inline' if that's what the C compiler
-   calls it, or to nothing if 'inline' is not supported under any name.  */
+	calls it, or to nothing if 'inline' is not supported under any name.  */
 #ifndef __cplusplus
 #undef inline
 #endif
 
 /* Define to the equivalent of the C99 'restrict' keyword, or to
-   nothing if this is not supported.  Do not define if restrict is
-   supported directly.  */
+	nothing if this is not supported.  Do not define if restrict is
+	supported directly.  */
 #undef restrict
 /* Work around a bug in Sun C++: it does not support _Restrict or
-   __restrict__, even though the corresponding Sun C compiler ends up with
-   "#define restrict _Restrict" or "#define restrict __restrict__" in the
-   previous line.  Perhaps some future version of Sun C++ will work with
-   restrict; if so, hopefully it defines __RESTRICT like Sun C does.  */
+	__restrict__, even though the corresponding Sun C compiler ends up with
+	"#define restrict _Restrict" or "#define restrict __restrict__" in the
+	previous line.  Perhaps some future version of Sun C++ will work with
+	restrict; if so, hopefully it defines __RESTRICT like Sun C does.  */
 #if defined __SUNPRO_CC && !defined __RESTRICT
 # define _Restrict
 # define __restrict__
diff --git a/src/include/port/pg_crc32c.h b/src/include/port/pg_crc32c.h
index ae008118ea8..91ecf3950d4 100644
--- a/src/include/port/pg_crc32c.h
+++ b/src/include/port/pg_crc32c.h
@@ -118,6 +118,9 @@ extern pg_crc32c pg_comp_crc32c_avx512(pg_crc32c crc, const void *data, size_t l
 #define FIN_CRC32C(crc) ((crc) ^= 0xFFFFFFFF)
 
 extern pg_crc32c pg_comp_crc32c_armv8(pg_crc32c crc, const void *data, size_t len);
+#ifdef USE_SVE2_CRC32C_WITH_RUNTIME_CHECK
+extern pg_crc32c pg_comp_crc32c_sve2(pg_crc32c crc, const void *data, size_t len);
+#endif
 
 #elif defined(USE_LOONGARCH_CRC32C)
 /* Use LoongArch CRCC instructions. */
@@ -139,8 +142,11 @@ extern pg_crc32c pg_comp_crc32c_loongarch(pg_crc32c crc, const void *data, size_
 #define FIN_CRC32C(crc) ((crc) ^= 0xFFFFFFFF)
 
 extern pg_crc32c pg_comp_crc32c_sb8(pg_crc32c crc, const void *data, size_t len);
-extern pg_crc32c (*pg_comp_crc32c) (pg_crc32c crc, const void *data, size_t len);
+extern PGDLLIMPORT pg_crc32c (*pg_comp_crc32c) (pg_crc32c crc, const void *data, size_t len);
 extern pg_crc32c pg_comp_crc32c_armv8(pg_crc32c crc, const void *data, size_t len);
+#ifdef USE_SVE2_CRC32C_WITH_RUNTIME_CHECK
+extern pg_crc32c pg_comp_crc32c_sve2(pg_crc32c crc, const void *data, size_t len);
+#endif
 
 #else
 /*
diff --git a/src/port/pg_crc32c_armv8.c b/src/port/pg_crc32c_armv8.c
index 5ba070bb99d..2b5a5c1f10f 100644
--- a/src/port/pg_crc32c_armv8.c
+++ b/src/port/pg_crc32c_armv8.c
@@ -73,3 +73,191 @@ pg_comp_crc32c_armv8(pg_crc32c crc, const void *data, size_t len)
 
 	return crc;
 }
+
+#ifdef USE_SVE2_CRC32C_WITH_RUNTIME_CHECK
+#include <arm_sve.h>
+#include <stddef.h>
+#include <stdint.h>
+#include <string.h>
+
+static const uint64_t k_8way_fold[2] __attribute__((aligned(16))) = {
+	0x000000006992cea2ULL,		/* x^1055 mod P(x) */
+	0x000000000d3b6092ULL		/* x^991 mod P(x) */
+};
+
+static const uint64_t k1k2_merge1[2] __attribute__((aligned(16))) = {
+	0x00000000f20c0dfeULL,		/* x^159 */
+	0x00000000493c7d27ULL		/* x^95 */
+};
+
+static const uint64_t k1k2_merge2[2] __attribute__((aligned(16))) = {
+	0x000000003da6d0cbULL,		/* x^287 */
+	0x00000000ba4fc28eULL		/* x^223 */
+};
+
+static const uint64_t k3k4_merge3[2] __attribute__((aligned(16))) = {
+	0x00000000740eef02ULL,		/* x^543 */
+	0x000000009e4addf8ULL		/* x^479 */
+};
+
+pg_attribute_target("arch=armv9-a+sve2-aes")
+static inline svuint64_t
+sve_load_crc(uint32_t crc)
+{
+	uint64_t	buf[4] = {(uint64_t) crc, 0};
+
+	return svld1_u64(svptrue_b64(), buf);
+}
+
+pg_attribute_target("arch=armv9-a+sve2-aes")
+pg_crc32c
+pg_comp_crc32c_sve2(pg_crc32c crc_in, const void *data, size_t length)
+{
+	const uint8_t *input = (const uint8_t *) data;
+	pg_crc32c	crc = crc_in;
+	svbool_t	pg = svptrue_b64();
+	size_t		vl_bytes = (size_t) svcntb();
+	svuint64_t	vK_fold = svld1_u64(pg, k_8way_fold);
+	svuint64_t	vK_merge1 = svld1_u64(pg, k1k2_merge1);
+	svuint64_t	vK_merge2 = svld1_u64(pg, k1k2_merge2);
+	svuint64_t	vK_merge3 = svld1_u64(pg, k3k4_merge3);
+
+	if (length < 8 * vl_bytes)
+		return pg_comp_crc32c_armv8(crc, input, length);
+
+	/* Initialize 8 accumulators */
+	svuint64_t	acc0 = svld1_u64(pg, (const uint64_t *) input);
+
+	acc0 = sveor_u64_z(pg, acc0, sve_load_crc(crc));
+
+	svuint64_t	acc1 = svld1_u64(pg, (const uint64_t *) (input + 1 * vl_bytes));
+	svuint64_t	acc2 = svld1_u64(pg, (const uint64_t *) (input + 2 * vl_bytes));
+	svuint64_t	acc3 = svld1_u64(pg, (const uint64_t *) (input + 3 * vl_bytes));
+	svuint64_t	acc4 = svld1_u64(pg, (const uint64_t *) (input + 4 * vl_bytes));
+	svuint64_t	acc5 = svld1_u64(pg, (const uint64_t *) (input + 5 * vl_bytes));
+	svuint64_t	acc6 = svld1_u64(pg, (const uint64_t *) (input + 6 * vl_bytes));
+	svuint64_t	acc7 = svld1_u64(pg, (const uint64_t *) (input + 7 * vl_bytes));
+
+	input += 8 * vl_bytes;
+	length -= 8 * vl_bytes;
+
+	/* Main loop */
+	while (length >= 8 * vl_bytes)
+	{
+		svuint64_t	block0 = svld1_u64(pg, (const uint64_t *) (input + 0 * vl_bytes));
+		svuint64_t	block1 = svld1_u64(pg, (const uint64_t *) (input + 1 * vl_bytes));
+		svuint64_t	block2 = svld1_u64(pg, (const uint64_t *) (input + 2 * vl_bytes));
+		svuint64_t	block3 = svld1_u64(pg, (const uint64_t *) (input + 3 * vl_bytes));
+		svuint64_t	block4 = svld1_u64(pg, (const uint64_t *) (input + 4 * vl_bytes));
+		svuint64_t	block5 = svld1_u64(pg, (const uint64_t *) (input + 5 * vl_bytes));
+		svuint64_t	block6 = svld1_u64(pg, (const uint64_t *) (input + 6 * vl_bytes));
+		svuint64_t	block7 = svld1_u64(pg, (const uint64_t *) (input + 7 * vl_bytes));
+
+		svuint64_t	t0_0 = svpmullb_pair_u64(acc0, vK_fold);
+		svuint64_t	t0_1 = svpmullb_pair_u64(acc1, vK_fold);
+		svuint64_t	t0_2 = svpmullb_pair_u64(acc2, vK_fold);
+		svuint64_t	t0_3 = svpmullb_pair_u64(acc3, vK_fold);
+		svuint64_t	t0_4 = svpmullb_pair_u64(acc4, vK_fold);
+		svuint64_t	t0_5 = svpmullb_pair_u64(acc5, vK_fold);
+		svuint64_t	t0_6 = svpmullb_pair_u64(acc6, vK_fold);
+		svuint64_t	t0_7 = svpmullb_pair_u64(acc7, vK_fold);
+
+		svuint64_t	t1_0 = svpmullt_pair_u64(acc0, vK_fold);
+		svuint64_t	t1_1 = svpmullt_pair_u64(acc1, vK_fold);
+		svuint64_t	t1_2 = svpmullt_pair_u64(acc2, vK_fold);
+		svuint64_t	t1_3 = svpmullt_pair_u64(acc3, vK_fold);
+		svuint64_t	t1_4 = svpmullt_pair_u64(acc4, vK_fold);
+		svuint64_t	t1_5 = svpmullt_pair_u64(acc5, vK_fold);
+		svuint64_t	t1_6 = svpmullt_pair_u64(acc6, vK_fold);
+		svuint64_t	t1_7 = svpmullt_pair_u64(acc7, vK_fold);
+
+		acc0 = sveor3_u64(t0_0, t1_0, block0);
+		acc1 = sveor3_u64(t0_1, t1_1, block1);
+		acc2 = sveor3_u64(t0_2, t1_2, block2);
+		acc3 = sveor3_u64(t0_3, t1_3, block3);
+		acc4 = sveor3_u64(t0_4, t1_4, block4);
+		acc5 = sveor3_u64(t0_5, t1_5, block5);
+		acc6 = sveor3_u64(t0_6, t1_6, block6);
+		acc7 = sveor3_u64(t0_7, t1_7, block7);
+
+		input += 8 * vl_bytes;
+		length -= 8 * vl_bytes;
+	}
+
+	/* Stage 1: Fold 128 bits */
+	{
+		svuint64_t	t0,
+					t1;
+
+		t0 = svpmullb_pair_u64(acc0, vK_merge1);
+		t1 = svpmullt_pair_u64(acc0, vK_merge1);
+		acc0 = sveor3_u64(t0, t1, acc1);
+
+		t0 = svpmullb_pair_u64(acc2, vK_merge1);
+		t1 = svpmullt_pair_u64(acc2, vK_merge1);
+		acc2 = sveor3_u64(t0, t1, acc3);
+
+		t0 = svpmullb_pair_u64(acc4, vK_merge1);
+		t1 = svpmullt_pair_u64(acc4, vK_merge1);
+		acc4 = sveor3_u64(t0, t1, acc5);
+
+		t0 = svpmullb_pair_u64(acc6, vK_merge1);
+		t1 = svpmullt_pair_u64(acc6, vK_merge1);
+		acc6 = sveor3_u64(t0, t1, acc7);
+	}
+
+	/* Stage 2: Fold 256 bits */
+	{
+		svuint64_t	t0,
+					t1;
+
+		t0 = svpmullb_pair_u64(acc0, vK_merge2);
+		t1 = svpmullt_pair_u64(acc0, vK_merge2);
+		acc0 = sveor3_u64(t0, t1, acc2);
+
+		t0 = svpmullb_pair_u64(acc4, vK_merge2);
+		t1 = svpmullt_pair_u64(acc4, vK_merge2);
+		acc4 = sveor3_u64(t0, t1, acc6);
+	}
+
+	/* Stage 3: Fold 512 bits */
+	{
+		svuint64_t	t0,
+					t1;
+
+		t0 = svpmullb_pair_u64(acc0, vK_merge3);
+		t1 = svpmullt_pair_u64(acc0, vK_merge3);
+		acc0 = sveor3_u64(t0, t1, acc4);
+	}
+
+	/* Remainder loop */
+	while (length >= vl_bytes)
+	{
+		svuint64_t	block = svld1_u64(pg, (const uint64_t *) input);
+
+		svuint64_t	t0 = svpmullb_pair_u64(acc0, vK_merge1);
+		svuint64_t	t1 = svpmullt_pair_u64(acc0, vK_merge1);
+
+		acc0 = sveor3_u64(t0, t1, block);
+
+		input += vl_bytes;
+		length -= vl_bytes;
+	}
+
+	/* Final reduction */
+	{
+		uint64_t	temp[2];
+
+		svst1_u64(pg, temp, acc0);
+
+		crc = 0;
+		crc = __crc32cd(crc, temp[0]);
+		crc = __crc32cd(crc, temp[1]);
+	}
+
+	if (length > 0)
+		crc = pg_comp_crc32c_armv8(crc, input, length);
+
+	return crc;
+}
+#endif
\ No newline at end of file
diff --git a/src/port/pg_crc32c_armv8_choose.c b/src/port/pg_crc32c_armv8_choose.c
index c0001cfe2dc..86aa9072f9a 100644
--- a/src/port/pg_crc32c_armv8_choose.c
+++ b/src/port/pg_crc32c_armv8_choose.c
@@ -26,8 +26,7 @@
 
 #if defined(HAVE_ELF_AUX_INFO) || defined(HAVE_GETAUXVAL)
 #include <sys/auxv.h>
-/* Ancient glibc releases don't include the HWCAPxxx macros in sys/auxv.h */
-#if defined(__linux__) && (defined(__aarch64__) ? !defined(HWCAP_CRC32) : !defined(HWCAP2_CRC32))
+#if defined(__linux__) && !defined(__aarch64__) && !defined(HWCAP2_CRC32)
 #include <asm/hwcap.h>
 #endif
 #endif
@@ -36,11 +35,45 @@
 #include <sys/sysctl.h>
 #if defined(__aarch64__)
 #include <aarch64/armreg.h>
+#include <arm_sve.h>
 #endif
 #endif
 
+#include <sys/prctl.h>
+
 #include "port/pg_crc32c.h"
 
+#ifndef PR_SVE_GET_VL
+#define PR_SVE_GET_VL 51
+#endif
+
+static bool
+pg_crc32c_sve2_available(void)
+{
+#if defined(__aarch64__)
+#ifdef HAVE_ELF_AUX_INFO
+	unsigned long hwcap, hwcap2;
+
+	/* Check for CRC32 and SVE2 on BSD systems */
+	if (elf_aux_info(AT_HWCAP, &hwcap, sizeof(hwcap)) != 0)
+		return false;
+	if (elf_aux_info(AT_HWCAP2, &hwcap2, sizeof(hwcap2)) != 0)
+		return false;
+	return (hwcap & HWCAP_CRC32) && (hwcap2 & HWCAP2_SVE2);
+#elif defined(HAVE_GETAUXVAL)
+	/* Check for CRC32 and SVE2 on Linux systems */
+	unsigned long hwcap = getauxval(AT_HWCAP);
+	unsigned long hwcap2 = getauxval(AT_HWCAP2);
+
+	return (hwcap & HWCAP_CRC32) && (hwcap2 & HWCAP2_SVE2);
+#else
+	return false;
+#endif
+#else
+	return false;
+#endif
+}
+
 static bool
 pg_crc32c_armv8_available(void)
 {
@@ -74,14 +107,17 @@ pg_crc32c_armv8_available(void)
 
 	size_t		len;
 	uint64		sysctlbuf[SYSCTL_CPU_ID_MAXSIZE];
+
 #if defined(__aarch64__)
 	/* We assume cpu0 is representative of all the machine's CPUs. */
 	const char *path = "machdep.cpu0.cpu_id";
 	size_t		expected_len = sizeof(struct aarch64_sysctl_cpu_id);
+
 #define ISAR0 ((struct aarch64_sysctl_cpu_id *) sysctlbuf)->ac_aa64isar0
 #else
 	const char *path = "machdep.id_isar";
 	size_t		expected_len = 6 * sizeof(int);
+
 #define ISAR0 ((int *) sysctlbuf)[5]
 #endif
 	uint64		fld;
@@ -115,7 +151,11 @@ pg_crc32c_armv8_available(void)
 static pg_crc32c
 pg_comp_crc32c_choose(pg_crc32c crc, const void *data, size_t len)
 {
-	if (pg_crc32c_armv8_available())
+	int vl = prctl(PR_SVE_GET_VL);
+
+	if (pg_crc32c_sve2_available() && vl > 0 && (vl & 0xFFFF) == 16) /* 16 bytes = 128 bits */
+		pg_comp_crc32c = pg_comp_crc32c_sve2;
+	else if (pg_crc32c_armv8_available())
 		pg_comp_crc32c = pg_comp_crc32c_armv8;
 	else
 		pg_comp_crc32c = pg_comp_crc32c_sb8;
@@ -123,4 +163,4 @@ pg_comp_crc32c_choose(pg_crc32c crc, const void *data, size_t len)
 	return pg_comp_crc32c(crc, data, len);
 }
 
-pg_crc32c	(*pg_comp_crc32c) (pg_crc32c crc, const void *data, size_t len) = pg_comp_crc32c_choose;
+pg_crc32c	(*pg_comp_crc32c) (pg_crc32c crc, const void *data, size_t len) = pg_comp_crc32c_choose;
\ No newline at end of file
-- 
2.34.1

